unit idmain;

interface

uses
{$IFDEF WIN32}
  Windows,
{$ELSE}
 Wintypes, WinProcs,
{$ENDIF}
 Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IceLock, ExtCtrls, Spin, ComCtrls, Variants, Buttons, ImgList,
  ToolWin, Grids, ValEdit;

type
  TForm1 = class(TForm)
    IceLock1: tIceLock;
    Panel1: TPanel;
    NameEdit: TEdit;
    Label4: TLabel;
    PermCheck: TCheckBox;
    BMake: TButton;
    BSave: TButton;
    BLoad: TButton;
    Label5: TLabel;
    SpinEdit1: TSpinEdit;
    Label7: TLabel;
    Label9: TLabel;
    EAppName: TEdit;
    DTP1: TEdit;
    ESave: TEdit;
    ELoad: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    FirstCheck: TCheckBox;
    Panel2: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    L1: TLabel;
    L2: TLabel;
    L3: TLabel;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    KE1: TEdit;
    KE2: TEdit;
    Label3: TLabel;
    Label6: TLabel;
    KE3: TEdit;
    KE4: TEdit;
    Label8: TLabel;
    KE5: TEdit;
    Label10: TLabel;
    KE6: TEdit;
    Panel4: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    VE: TValueListEditor;
    KVE: TValueListEditor;
    Label11: TLabel;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure PermCheckClick(Sender: TObject);
    procedure BMakeClick(Sender: TObject);
    procedure BSaveClick(Sender: TObject);
    procedure BLoadClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ESaveChange(Sender: TObject);
    procedure ELoadChange(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure KE1Change(Sender: TObject);
    procedure KE2Change(Sender: TObject);
    procedure KE3Change(Sender: TObject);
    procedure KE4Change(Sender: TObject);
    procedure KE5Change(Sender: TObject);
    procedure KE6Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure KVEStringsChange(Sender: TObject);
  private
    FUpdating: Boolean; 
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CHInt: LongInt;
  CHByte: Byte;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  Result : integer;
begin
  Result := Icelock1.LoadKeyFile;
  if Result = ieOkay then
  begin
    if IceLock1.IsRegistered then
    begin
      Edit1.Text := Icelock1.GetName;
      Edit2.Text := Icelock1.GetKey;
      Edit3.Text := DateTimeToStr(IceLock1.ExpirationDate);
    end;
  end
  else Edit1.Text := ieErrString[Result];
  SpinEdit1.Value := Icelock1.TrialDays;
  if Icelock1.CreationDate > 0 then
     DTP1.Text := DateTimeToStr(Icelock1.CreationDate)
  else DTP1.Text := '';
  EAppName.Text := Icelock1.AppName;
  ESave.Text := Icelock1.KeyFile;
  ELoad.Text := Icelock1.KeyFile;
  FUpdating := True;
  KE1.Text := IntToStr(Icelock1.IceSeed1);
  KE2.Text := IntToStr(Icelock1.IceSeed2);
  KE3.Text := Icelock1.IceString1;
  KE4.Text := Icelock1.IceString2;
  KE5.Text := IntToStr(Icelock1.ProgramKey1);
  KE6.Text := IntToStr(Icelock1.ProgramKey2);
  FUpdating := False;
end;

procedure TForm1.PermCheckClick(Sender: TObject);
begin
  if PermCheck.Checked then IceLock1.DemoLicense := false
    else IceLock1.DemoLicense := true;
end;

procedure TForm1.BMakeClick(Sender: TObject);
begin
  FUpdating := True;
  IceLock1.IceSeed1 := StrToInt(KE1.Text);
  IceLock1.IceSeed2 := StrToInt(KE2.Text);
  IceLock1.IceString1 := KE3.Text;
  IceLock1.IceString2 := KE4.Text;
  IceLock1.ProgramKey1 := StrToInt(KE5.Text);
  IceLock1.ProgramKey2 := StrToInt(KE6.Text);
  FUpdating := False;
  Edit2.Text := IceLock1.BuildUserKey(NameEdit.Text,Icelock1.DemoLicense);
  Edit3.Text := DateTimeToStr(IceLock1.ExpirationDate);
end;

procedure TForm1.BSaveClick(Sender: TObject);
begin
  IceLock1.KeyFile := ESave.Text;
  IceLock1.AppName := EAppName.Text;
  if Icelock1.PutKey(NameEdit.Text,Edit2.Text) = ieOkay then begin
    if Icelock1.SaveKeyFile(FirstCheck.Checked) <>  ieOkay then
       Edit2.Text := 'Not Saved';
  end
  else Edit2.Text := 'ERROR';
  if Icelock1.CreationDate > 0 then
     DTP1.Text := DateTimeToStr(Icelock1.CreationDate)
  else DTP1.Text := '';
  Edit3.Text := DateTimeToStr(IceLock1.ExpirationDate);
end;

procedure TForm1.BLoadClick(Sender: TObject);
var
  Result : integer;
begin
  IceLock1.KeyFile := ELoad.Text;
  IceLock1.AppName := EAppName.Text;
  Result := Icelock1.LoadKeyFile;
  if Result = ieOkay then
  begin
    if IceLock1.IsRegistered then
    begin
      Edit1.Text := Icelock1.GetName;
      Edit2.Text := Icelock1.GetKey;
      Edit3.Text := DateTimeToStr(IceLock1.ExpirationDate);
    end;
  end
  else Edit1.Text := ieErrString[Result];
  if Icelock1.CreationDate > 0 then
     DTP1.Text := DateTimeToStr(Icelock1.CreationDate)
  else DTP1.Text := '';
  Edit3.Text := DateTimeToStr(IceLock1.ExpirationDate);
  EAppName.Text := IceLock1.AppName;
  KE5.Text := IntToStr(IceLock1.ProgramKey1);
  KE6.Text := IntToStr(IceLock1.ProgramKey2);
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Icelock1.TrialDays := SpinEdit1.Value;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  with TSaveDialog.Create(Application) do begin
    InitialDir := GetCurrentDir;
    DefaultExt := '.Key';
    Filter := 'Licens Files|*.key|All FIles|*.*';
    try
      if Execute then
         ESave.Text := FileName;
    finally
      Free;
    end;
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  with TOpenDialog.Create(Application) do begin
    InitialDir := GetCurrentDir;
    DefaultExt := '.Key';
    Filter := 'Licens Files|*.key|All FIles|*.*';
    try
      if Execute then
         ELoad.Text := FileName;
    finally
      Free;
    end;
  end;
end;

procedure TForm1.ESaveChange(Sender: TObject);
begin
  IceLock1.KeyFile := ESave.Text;
end;

procedure TForm1.ELoadChange(Sender: TObject);
begin
  IceLock1.KeyFile := ELoad.Text;
end;

procedure TForm1.KE1Change(Sender: TObject);
begin
  if not FUpdating then begin
     try
       IceLock1.IceSeed1 := StrToInt(KE1.Text);
     except
       ShowMessage(KE1.Text+' is not valid integer value!');
       KE1.Text := IntToStr(IceLock1.IceSeed1);
     end;
  end;
end;

procedure TForm1.KE2Change(Sender: TObject);
begin
  if not FUpdating then begin
     try
       IceLock1.IceSeed2 := StrToInt(KE2.Text);
     except
       ShowMessage(KE2.Text+' is not valid integer value!');
       KE2.Text := IntToStr(IceLock1.IceSeed2);
     end;
  end;
end;

procedure TForm1.KE3Change(Sender: TObject);
begin
  if not FUpdating then
     IceLock1.IceString1 := KE3.Text;
end;

procedure TForm1.KE4Change(Sender: TObject);
begin
  if not FUpdating then
     IceLock1.IceString2 := KE4.Text;
end;

procedure TForm1.KE5Change(Sender: TObject);
begin
  try
    CHInt := StrToInt(KE5.Text);
  except
    KE5.Undo;
  end;
  KE5.ClearUndo;
end;

procedure TForm1.KE6Change(Sender: TObject);
begin
  try
    CHInt := StrToInt(KE6.Text);
  except
    KE6.Undo;
  end;
  KE6.ClearUndo;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
var
  r  : rIceRecord;
  pa : pIceArray;
  f: file of aIceArray;
  FName: string;
  MasterKey : array[0..7] of byte;
  I: integer;

  procedure EncryptRecord(p : Pointer);
  //MasterKey : array[0..7] of byte = {+++ Bug (x mod 8) ranges from 0 to 7 }
  //          (( 89),( 66),(128),(231),( 18),( 43),(113),( 67));

  var
    pr : pIceArray;
    x  : byte;
  begin
    pr := p;
    for x := 1 to sizeof(rIceRecord) do
    begin
      pr^[x] := pr^[x] xor masterkey[x mod 8];
    end;
  end;

begin
  FName := '';
  for I := 0 to 7 do
    MasterKey[I] := StrToInt(KVE.Strings.ValueFromIndex[I]);
  //MasterKey : array[0..7] of byte = {+++ Bug (x mod 8) ranges from 0 to 7 }
  //          (( 89),( 66),(128),(231),( 18),( 43),(113),( 67));
  with TOpenDialog.Create(Application) do begin
    InitialDir := GetCurrentDir;
    DefaultExt := '.Key';
    Filter := 'Licens Files|*.key|All FIles|*.*';
    try
      if Execute then
         FName := FileName;
    finally
      Free;
    end;
  end;
  if FName = '' then Exit;
  AssignFile(f,FName);
  {$I-}
  reset(f);
  {$I+}
  if IoResult = 0 then begin
    pa := @r;
    {$I-}
    read(f,pa^);
    {$I+}
    if IoResult = 0 then
    begin
      EncryptRecord(@r);
      VE.Strings.ValueFromIndex[0] := r.AppName;
      VE.Strings.ValueFromIndex[1] := r.Name;
      VE.Strings.ValueFromIndex[2] := r.Key;
      VE.Strings.ValueFromIndex[3] := IntToStr(r.HDSerialNo);
      if r.DemoLicense then
         VE.Strings.ValueFromIndex[4] := 'Demo license'
      else VE.Strings.ValueFromIndex[4] := 'No Demo license';
      VE.Strings.ValueFromIndex[5] := DateTimeToStr(r.ExpirationDate);
      VE.Strings.ValueFromIndex[6] := DateTimeToStr(r.CreationDate);
      VE.Strings.ValueFromIndex[7] := IntToStr(r.Key1);
      VE.Strings.ValueFromIndex[8] := IntToStr(r.Key1);
    end;
    closefile(f);
  end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
var
  SFS: TStrings;
  I: integer;
begin
  with TSaveDialog.Create(Application) do begin
    InitialDir := GetCurrentDir;
    DefaultExt := '.TXT';
    Filter := 'Text Files|*.txt|All FIles|*.*';
    try
      if Execute then begin
         if FileExists(FileName) then begin
            if MessageDlg('Rewrite File?', mtConfirmation, [mbYes, mbNo],0) <> mrYes then
               Exit;
         end;
         SFS := TStringList.Create;
         try
           SFS.Text := VE.Strings.Text;
           SFS.Add(' ');
           SFS.Add('------------------------------');
           SFS.Add(' Master Keys (Byte) ');
           SFS.Add('------------------------------');
           SFS.Add(' ');
           for I := 0 to KVE.Strings.Count - 1 do
               SFS.Add('Key_'+IntToStr(I)+'='+KVE.Strings.ValueFromIndex[I]);
           SFS.SaveToFile(FileName);
         finally
           SFS.Free;
         end;
      end;
    finally
      Free;
    end;
  end;
end;

procedure TForm1.KVEStringsChange(Sender: TObject);
var
  Value: string;
  ACol, ARow: integer;
begin
  if FUpdating then Exit;
  FUpdating := True;
  KVE.MouseToCell(Mouse.CursorPos.X - KVE.ClientOrigin.X,Mouse.CursorPos.Y - KVE.ClientOrigin.Y,ACol,ARow);
  Value := KVE.Cells[ACOl, ARow];
  CHInt := StrToInt(Value);
  if ((CHInt < 0) or (CHInt > 255)) then begin
     SHowMessage(Value + ' Is Invalid Byte value!');
     Value := '';
  end;
  try
    KVE.Cells[ACOl, ARow] := Value;
  finally
    FUpdating := False;
  end;
end;

end.
